#include <SPI.h>
#include <Ethernet.h>
#include <EthernetUdp.h>

// PIN Settings
#define Bewegungsmelder 2

// Variable Declaration
char BewegungsmelderState = 0;
int Helligkeitssensor = 0;
int HelligkeitssensordIdle = 100;
int HelligkeitssensorCounter = 0;
int HelligkeitssensorSchwellwert = 5;
int HelligkeitssensorObergrenze = 0;
int HelligkeitssensorUntergrenze = 0;
char msg[25];

// Network Settings
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };
IPAddress ip(192, 168, 3, 19);
IPAddress gateway(192, 168, 3, 1);
IPAddress subnet(255, 255, 255, 0);

// Local UDP port to listen on
unsigned int localPort = 7002;

// Recipient IP
IPAddress RecipientIP(192, 168, 3, 11);

// Recipient UDP Port
unsigned int RecipientPort = 7001;

// buffers for receiving and sending data
char packetBuffer[UDP_TX_PACKET_MAX_SIZE];

// An EthernetUDP instance to send and receive packets over UDP
EthernetUDP Udp;

void setup()
{
  // for debug only
  Serial.begin(9600);

  // start Ethernet
  Ethernet.begin(mac,ip);

  // Start UDP
  Udp.begin(localPort);

  // Bewegungsmelder 
  pinMode(Bewegungsmelder, INPUT);

  // send UDP Ready 
  sendUDP("UDP Ready");
}

void loop()
{

// Bewegungsmelder (Send)
  if (digitalRead(Bewegungsmelder) == LOW && BewegungsmelderState != 0)
  {
    sendUDP("WZ.Bewegungsmelder: 0");
    BewegungsmelderState = 0;
  }

  if (digitalRead(Bewegungsmelder) == HIGH && BewegungsmelderState != 1)
  {
    sendUDP("WZ.Bewegungsmelder: 1");
    BewegungsmelderState = 1;
  }

  // Helligkeitssensor (Send)
  Helligkeitssensor=analogRead(A0);

  HelligkeitssensorCounter = HelligkeitssensorCounter + 1;

  if (Helligkeitssensor >= HelligkeitssensorObergrenze || Helligkeitssensor <= HelligkeitssensorUntergrenze)
  {

    if (HelligkeitssensorCounter >= HelligkeitssensordIdle)
    {
      sprintf(msg, "WZ.Helligkeitssensor: %d", Helligkeitssensor);
      Serial.println(msg);
      sendUDP(msg);

      HelligkeitssensorObergrenze = Helligkeitssensor + HelligkeitssensorSchwellwert;
      HelligkeitssensorUntergrenze = Helligkeitssensor - HelligkeitssensorSchwellwert;
      HelligkeitssensorCounter = 0;
    }
  }

delay(20);
}

// Function to send UDP packets
void sendUDP(String text)
{
    Udp.beginPacket(RecipientIP, RecipientPort);
    // Udp.write("Test");
    Udp.print(text);
    Udp.endPacket();
    //delay(10);
}
